<template>
  <q-toolbar class="bg-primary text-white raised">
    <q-toolbar-title role="heading">Presentations
      <q-badge align="top" outline v-if="presentations_filtered">
        {{ presentations_filtered.length }}
      </q-badge>
      <q-badge align="top" outline v-else>0</q-badge>
    </q-toolbar-title>
  </q-toolbar>
  <q-card>
    <q-card-section>
      <q-input label="filter" v-model="search_value" autofocus title="Filter tabellen">
        <template v-slot:prepend>
          <q-icon name="filter_alt"/>
        </template>
      </q-input>
    </q-card-section>
  </q-card>

  <q-list bordered class="detail--padding scroll_list">
    <q-item clickable v-ripple
            v-for="(node, index) in presentations_filtered"
            v-bind:id="node.id"
            v-bind:key="index"
            :class="node.node_type"
            active-class="active"
            :dts_name="dts_name"
            :to="{name: 'presentation_detail',
                    params: {rowid: node.rowid}}">
      <q-item-section>
        <q-item-label :class="item_class(node)" v-html="show_label(node.concept)"></q-item-label>
      </q-item-section>
    </q-item>
    <q-inner-loading :showing="typeof this.presentations=='undefined'">
      <q-circular-progress
        class="text-blue-grey"
        indeterminate
        size="50px"
        :thickness="0.22"
        v-if="typeof this.presentations=='undefined'"></q-circular-progress>
    </q-inner-loading>

  </q-list>

</template>

<script>
import {api} from 'boot/axios'
import _ from 'lodash'
import SharedMethods from "components/SharedMethods";

export default {
  name: "PresentationHierarchyList",
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
    this.fetchData()
  },
  data() {
    return {
      presentations: undefined,
      search_value: ''
    }
  },
  props: {
    dts_name: String,
    nt_version: String
  },

  methods: {
    fetchData: function () {
      api
        .get("/dts/" + this.dts_name + "/presentations", {params: {nt_version: this.nt_version}})
        .then(response => {
          this.presentations = response.data
          if (this.presentations.length && this.$route.fullPath.endsWith('presentations')) {
            this.$router.push({
              name: 'presentation_detail',
              replace: true,
              params: {rowid: this.presentations[0].rowid}
            })
          } else {
            this.$nextTick(() => {
              this.scroll_to_active()
            })
          }
        })
        .catch((error) => {
          this.presentations = []
        })

    },
    scroll_to_active: function () {
      let activelist = document.getElementsByClassName('active')
      if (activelist.length) {
        let el = activelist[0]
        let offset = el.getBoundingClientRect().top - window.scrollY - 100
        if (offset > window.innerHeight || offset < 0) {
          this.$nextTick(() => {
              el.scrollIntoView(true)
            }
          )
        }
      }
    },
    item_class: function (node) {
      if (node.dts_name) {
        return 'toc'
      }
      return 'linkrole'
    }

  },
  computed: {
    presentations_filtered() {
      if (!_.isUndefined(this.search_value) && this.search_value.length > 1) {
        return this.presentations.filter(presentation => presentation.concept &&
          this.get_label(presentation.concept).toLowerCase().includes(this.search_value.toLowerCase()))
      } else {
        return this.presentations
      }
    }
  }

}
</script>

<style scoped lang="scss">
.active {
  background: $list_selected_bg;
  color: white;
}

.scroll_list {
  overflow-y: auto;
  height: calc(100vh - 290px);
}

</style>
